/*
** CCTT - Covert Channel Tunneling Tool - v0.1.7
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: channels.h,v 1.8 2003/06/10 15:21:16 simsim Exp $
**
** This file is part of CCTT - v0.1.7 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
** Structure de pointeur sur fonction pour les types de canaux
*/

typedef struct S_channel_types
{
  char *channel_name;
  void (*channel_type_client)(S_OPTIONS *options);
  void (*channel_type_server)(S_OPTIONS *options, int sd, char *buffer, int nwr);
} T_channel_types;

extern T_channel_types channel_types_array[];

/*
** Prototypage
*/

/* Fonctions Client */

int channel_do_socket_rshell(S_OPTIONS *options);
int channel_do_socket_go(S_OPTIONS *options);

void channel_do_socket(S_OPTIONS *options);
void channel_do_socket_http_proxy(S_OPTIONS *options);
void channel_do_client_only_with_http_proxy(S_OPTIONS *options);

void channel_do_http(S_OPTIONS *options);

void channel_do_test(S_OPTIONS *options);

/* Fonctions Server */

void server_do_socket(S_OPTIONS *options, int sd, char *buffer, int nwr);
void server_do_test(S_OPTIONS *options, int sd, char *buffer, int nwr);

void do_channel(S_OPTIONS *options, int sd, char *buffer, int nwr);
void check_channel(S_OPTIONS *options);


