/*
** CCTT - Covert Channel Tunneling Tool - v0.1.5
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: configuration.h,v 1.3 2003/06/10 15:21:16 simsim Exp $
**
** This file is part of CCTT - v0.1.5 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
** Figurent ici differentes variables relatives a la configuration par defaut de CCTT.
** Certaines de ces variables sont aisemment modifiables.
** Pour d'autres, il est reccomande de savoir ce que vous faites.
*/

/*
** Valeurs precisees par defaut dans le synopsis
*/

#define DEFAULT_SRV_LISTEN_PORT 4242
#define DEFAULT_CL_CONNECT_PORT 4242
#define DEFAULT_CHANNEL_TYPE "socket"
#define DEFAULT_SRV_CONF_FILE "cctt_srv.cf"
#define DEFAULT_CL_CONF_FILE "cctt_cl.cf"

/*
** Logging par defaut
*/

#define DEFAULT_LOG_FILE "rshells.log"
#define DEFAULT_SYSLOG_FACILITY "daemon"
#define DEFAULT_SYSLOG_PRIORITY "notice"

/* 
** Localisation des shell client et serveur par defaut s'ils ne sont
** pas definis dans les fichiers de configuration
*/

#define CL_RSHELL_LOCATION "/usr/local/bin/bash"
#define CL_RSHELL_NAME "bash"
#define SRV_RSHELL_LOCATION "/bin/false"
#define SRV_RSHELL_NAME "false"

/* 
** A partir d'ici, vous devriez !!! VRAIMENT !!! savoir ce que vous faites
*/

/* 
** Taille des buffers d'ES au niveau des read/write sur la(les) sockets 
*/

#define SOCKET_BUFFER_SIZE 2048
#define SRV_SOCKET_BUFFER_SIZE 2048

/* 
** Temp d'attente (en msecs) avant d'envoyer le buffer lu sur une socket aux fonctions de traitement.
** Je reccomande 1000 ce qui correspond a peu pres a l'attente de 10 select apres le premier read (0.1 seconde).
*/

#define WAITIME_BEFORE_ACTION 2000

/* 
** Taille max du buffer a envoyer pour traitement apres concatenation des buffers recus sur les sockets 
** Note : Il doit etre superieur a SRV_SOCKET_BUFFER_SIZE.
*/

#define ACTION_BUFFER_SIZE 8192

/*
** Les defines pour le mode HTTP
*/

/* Defines HTTP_POST ([cl|srv]_build_and_send_http_functions.c) */

#define HTTP_STD_POST "POST "
#define HTTP_STD_HTTPV " HTTP/1.1"
#define HTTP_STD_HOST "Host: "
#define HTTP_STD_CLENGTH "Content-Length: "
#define HTTP_STD_CTYPE "Content-Type: "

#define HTTP_STD_OK "HTTP/1.1 200 OK"
#define HTTP_STD_DATE "Date: Mon, 9 June 2003 12:22:28 GMT"
#define HTTP_STD_SERVER "Server: CCTT-0.1.7"
#define HTTP_STD_CTYPE_SRV "Content-Type: text/html"

/*
** Defines par defaut pour la fermeture automatique des connexions...
** en msecs
*/

#define DEF_KILL_QUIET_DEL 1000000
#define DEF_KILL_QUIET_DEL_CF 300000
