/*
** CCTT - Covert Channel Tunneling Tool - v0.1.7
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: definitions.h,v 1.9 2003/06/10 15:21:16 simsim Exp $
**
** This file is part of CCTT - v0.1.7 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* 
** Inclusion des definitions systeme 
** !!! L'ordre doit etre strictement respecte pour une 
** compilation sous OpenBSD !!!
*/

#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <netdb.h>
#include <popt.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <time.h>
#include <unistd.h>
#include <syslog.h>
#include <stdarg.h>
#include <pwd.h>
#include <ctype.h>

/* Specifique wait3 */
#define _USE_BSD
#include <sys/resource.h>
#include <sys/wait.h>

/*
** Version
*/

#define	NAME		"Cctt"
#define LONGNAME        "Covert Channel Tunneling Tool"
#define	VERSION_CODE	0x000107
#define	DATE_CODE	0x090503

#define CCTT_VERSION(version)\
	(version >> 16) & 0xFF,\
	(version >> 8) & 0xFF,\
	version & 0xFF

#define VERSION NAME" - "LONGNAME" - v%d.%d.%d (%.2d/%.2d, 20%.2d)\n",\
	CCTT_VERSION(VERSION_CODE),\
	CCTT_VERSION(DATE_CODE)

/*
** Valeur de debug positionnee dans main.c .
** A 1, le debug fournit les informations minimales.
** A 2, le debug fournit plus d'information - le nombre d'octets ecrits ou lu sur les sockets par exemple.
*/

int GLOBAL_DEBUG;

/*
** Inclusion des defintions internes
*/ 

#include "configuration.h" /* Configuration CCTT */
#include "server.h"  /* Structure relative au serveur */
#include "client.h"  /* Structure relative au client */
#include "structs.h" /* Elements de base ccfe incluant les structures server et client */

/* 
** Prototypage 
*/

/* Includes generaux */
#include "conf_file_functions.h"
#include "basic_encoding.h"

/* Includes client */
#include "channels.h"
#include "cl_identification.h"
#include "send_cl_proxying_request.h"

/* Include server */
#include "do_server.h"
#include "parse_cmd_functions.h"
#include "srv_ident_client.h"

/* Prototypage */
#include "prototypage.h"
