/*
** CCTT - Covert Channel Tunneling Tool - v0.1.5
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: structs.h,v 1.5 2003/04/23 06:56:15 simsim Exp $
**
** This file is part of CCTT - v0.1.5 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
** Structure d'options passees en parametres a Ccfe
*/

typedef struct
{

  /*
  ** Les 16 bits de l'octet renseignent les options
  ** demandees par l'utilisateur :
  ** 0x xxx1xxxx xxxxxxxx = 0 ou 1 => Client is in reverse proxy-mode ?
  ** 0x xxxx1xxx xxxxxxxx = 0 ou 1 => Logging to syslog ?
  ** 0x xxxxx1xx xxxxxxxx = 0 ou 1 => Le client doit il se connecter a un proxy ?
  ** 0x xxxxxx1x xxxxxxxx = 0 ou 1 => Verifie la syntaxe du fichier de configuration et sort ?
  ** 0x xxxxxxx1 xxxxxxxx = 0 ou 1 => Debug Mode ?
  ** 0x xxxxxxxx 1xxxxxxx = 0 ou 1 => Verbose ?
  ** 0x xxxxxxxx x1xxxxxx = 0 ou 1 => Fichier de config ?
  ** 0x xxxxxxxx xx1xxxxx = 0 ou 1 => Logging ?
  ** 0x xxxxxxxx xxx1xxxx = 0 ou 1 => Reverse Shell ?
  ** 0x xxxxxxxx xxxx1xxx = 0 ou 1 => Client is in proxy_mode ?
  ** 0x xxxxxxxx xxxxx1xx = 0 ou 1 => Client wants the list of server proxy_mode ?
  ** 0x xxxxxxxx xxxxxx1x = 0 ou 1 => Client works in normal mode ?
  ** 0x xxxxxxxx xxxxxxx1 = 0 ou 1 => Using client or server ?
  */
  unsigned short options;
  
  /*
  ** Type de canal
  */
  char *channel;

  /*
  ** Type d'identification
  ** et cle associee
  */
  char *identification;
  char *ident_key;

  /* 
  ** Pointeur vers le nom du fichier de configuration 
  ** et vers son file descripteur
  */
  char *conf_file;
  int  fd_conf_file;

  /*
  ** Structure d'options de la configuration serveur
  */
  S_SERVER *srv_options;

  /*
  ** Structure d'options de la configuration client
  */
  S_CLIENT *cl_options;

} S_OPTIONS;

/*
** Variable globale de la structure options
*/

S_OPTIONS *options;

/*
** Macros associees a la structure
*/

#define OPT_CL_REV_PROX_MOD() ((options->options>>12)&0x01)
#define OPT_LOGGING_SYSLOG() ((options->options>>11)&0x01)
#define OPT_CL_CHAN_PROXY() ((options->options>>10)&0x01)
#define OPT_CHK_CONF_FILE() ((options->options>>9)&0x01)
#define OPT_DEBUG()         ((options->options>>8)&0x01)
#define OPT_VERBOSE()       ((options->options>>7)&0x01)
#define OPT_CONFFILE()      ((options->options>>6)&0x01)
#define OPT_LOGGING()       ((options->options>>5)&0x01)
#define OPT_RSHELL()        ((options->options>>4)&0x01)
#define OPT_CL_PROX_MOD()   ((options->options>>3)&0x01)
#define OPT_CL_LIST_MOD()   ((options->options>>2)&0x01)
#define OPT_CL_NORMAL_MOD() ((options->options>>1)&0x01)
#define OPT_CL_OR_SRV()     ((options->options>>0)&0x01)

#define OPT_DEBUG2()        (GLOBAL_DEBUG == 2 ? 1 : 0)
