/*
** CCTT - Covert Channel Tunneling Tool - v0.1.5
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: basic_encoding.c,v 1.5 2003/04/23 07:06:10 simsim Exp $
**
** This file is part of CCTT - v0.1.5 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/definitions.h"

/*
** Ces fonctions permettent un codage succint des donnees
** echangees entre serveur et clients.
*/

unsigned char be_get_key_length(char *key)
{
  int i;
  unsigned char sum;
  
  for (i=0,sum=0;i<strlen(key);i++)
    sum += (unsigned char) key[i];
  return (sum%256);
}

unsigned char be_get_tr_length(int i, unsigned int keylength, char *alphabet)
{
  unsigned char stat_alph;

  stat_alph = (unsigned char) alphabet[i%strlen(alphabet)];

  return (((stat_alph+keylength)%256));
}

char *basic_encode(char *src, unsigned char keylength, char *alphabet, int size)
{
  unsigned char *dst;
  unsigned char tmpc;
  unsigned char tmp[4];
  int i,j;

  dst = (char *) malloc((size*2)+3);
  memset (dst,0,(size*2)+3);

  for (i=0,j=0;i<size;i++,j+=2)
    {
      tmpc = (unsigned char) src[i];
      tmpc = (tmpc + be_get_tr_length(i,keylength,alphabet)) % 256 ;
      snprintf (tmp,4,"%x",tmpc);
      dst[j] = (tmp[0] == 0 ? '0' : tmp[0]);
      if (tmp[1] == 0)
	{
	  dst[j] = '0';
	  dst[j+1] = (tmp[0] == 0 ? '0' : tmp[0]);
	}
      else
	dst[j+1] = tmp[1];
    }
  dst[j] = '/';
  dst[j+1] = '/';
  return (dst);
}

T_basic_decode basic_decode(char *src, unsigned char keylength, char *alphabet,S_OPTIONS *options, int cl_num)
{
  unsigned int tmpc;
  unsigned char tmp[3];
  int i,j,k,l;

  T_basic_decode basdec;

  basdec.decoded = (char *) malloc((strlen(src)/2)+1);
  memset (basdec.decoded,0,(strlen(src)/2)+1);
  
  if (OPT_CL_OR_SRV())
    {
      for (i=0,j=0,k=(OPT_CL_PROX_MOD()?options->cl_options->client_sd_table[cl_num].basdec_alph_pos:G_basdec_alph_pos),l=0;
	   i<strlen(src);i+=2,j++)
	{
	  if (src[i] != '/')
	    {
	      tmp[0] = (unsigned char) src[i];
	      tmp[1] = (unsigned char) src[i+1];
	      tmp[2] = '\0';
	      tmpc = strtol(tmp,(char **) NULL,16);
	      basdec.decoded[j] = (unsigned char) (tmpc - be_get_tr_length(k,keylength,alphabet)) % 256 ;
	      k += 1;
	    }
	  else
	    {
	      if (OPT_CL_PROX_MOD())
		options->cl_options->client_sd_table[cl_num].basdec_alph_pos = k = 0;
	      else
		G_basdec_alph_pos = k = 0;
	      l++;
	      j--;
	    }
	}
      basdec.size = (strlen(src)/2)-l;
      if (OPT_CL_PROX_MOD())
	options->cl_options->client_sd_table[cl_num].basdec_alph_pos = k;
      else
	G_basdec_alph_pos = k;
      return (basdec);
    }
  else
    {
      for (i=0,j=0,k=options->srv_options->connect_infos->sd_table[cl_num].basdec_alph_pos,l=0;i<strlen(src);i+=2,j++)
	{
	  if (src[i] != '/')
	    {
	      tmp[0] = (unsigned char) src[i];
	      tmp[1] = (unsigned char) src[i+1];
	      tmp[2] = '\0';
	      tmpc = strtol(tmp,(char **) NULL,16);
	      basdec.decoded[j] = (unsigned char) (tmpc - be_get_tr_length(k,keylength,alphabet)) % 256 ;
	      k += 1;
	    }
	  else
	    {
	      options->srv_options->connect_infos->sd_table[cl_num].basdec_alph_pos = k = 0;
	      l++;
	      j--;
	    }
	}
      basdec.size = (strlen(src)/2)-l;
      options->srv_options->connect_infos->sd_table[cl_num].basdec_alph_pos = k;
      return (basdec);
    }
}

