/*
** CCTT - Covert Channel Tunneling Tool - v0.1.7
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: channel_do_http.c,v 1.2 2003/06/10 15:21:16 simsim Exp $
**
** This file is part of CCTT - v0.1.7 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/definitions.h"

void channel_do_http(S_OPTIONS *options)
{
  int ret_val=0;

  /* 
  ** On verifie que le fichier de configuration ne contient pas 
  ** de coordonnees de proxy ou qu'il les contient si besoin est.
  */
  if (tell_me_about_http(options) == 1 && OPT_CL_CHAN_PROXY())
    cctt_error_and_exit(stderr,"%s","[Conf] : CHANNEL_PROXY_ configuration directives used ?!?!?");
  if (tell_me_about_http(options) == 2 && !OPT_CL_CHAN_PROXY())
    cctt_error_and_exit(stderr,"%s","[Conf] : CHANNEL_PROXY_ configuration directives are not used in this proxy mode ?!?!?");
  
  /*
  ** On initialise les compteurs HTTP
  */
  options->cl_options->http_mode_req_per_con_ctr = 0;

  /*
  ** On y va pour le traitement
  */

  if (OPT_CL_PROX_MOD()) /* Client en mode proxy */
    ret_val = client_binds_local_proxy(options);
  else
    {
      /*
      ** On s'identifie aupres du serveur (la connexion sera ouverte en interne des fonctions HTTP)
      ** => Cela permet d'ouvrir la premiere des connexions qui positionnera un socket descriptor
      **    que les fonctions de gestion utiliseront dans leur select.
      */
      client_socket(options);

      /*
      ** Si on est dans un mode http avec proxy
      */
      if (OPT_CL_CONNECTED() && OPT_CL_CHAN_PROXY())
	client_use_border_proxy(options);

      cl_identification(options,0);
      if (!OPT_CL_CONNECTED())
	cctt_error_and_exit(stderr,"%s","[HTTP] : Connection is closed. Aborting.");

      if (OPT_RSHELL()) /* Si le client est un reverse shell */
	{
	  ret_val = channel_do_socket_rshell(options);
	  if (ret_val == -1) cctt_debug(stderr,"%s","[TMP] : Une erreur est survenue : channel_do_socket.c\n");
	}
      if (OPT_CL_NORMAL_MOD() || OPT_CL_LIST_MOD())
	{
	  /* Shell normal ou demande de la liste de proxy */
	  ret_val = channel_do_socket_go(options);
	  if (ret_val == -1) cctt_debug(stderr,"%s","[TMP] : Une erreur est survenue : channel_do_socket.c\n");
	}
      if (OPT_CL_REV_PROX_MOD())
	{
	  ret_val = client_asks_reverse_prox_mode(options);
	  if (ret_val == -1) cctt_debug(stderr,"%s","[TMP] : Une erreur est survenue : channel_do_socket.c\n");
	}
    }
}
