/*
** CCTT - Covert Channel Tunneling Tool - v0.1.5
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: cl_set_request.c,v 1.6 2003/06/10 15:21:16 simsim Exp $
**
** This file is part of CCTT - v0.1.5 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/definitions.h"

/*
** Retourne le type de requete que le client demande
** en fonction des parametres de son initialisation.
** Voir includes/cl_identification.h
*/

char cl_set_request(int cont)
{
  char request;

  request = '0';

  if (cont == 0)
    {
  if (OPT_CL_NORMAL_MOD())
    request = CL_IDENT_ASKED_SHELL;
  if (OPT_RSHELL())
    request = CL_IDENT_REV_SHELL;
  if (OPT_CL_LIST_MOD())
    request = CL_IDENT_LIST_PROX;
  if (OPT_CL_PROX_MOD())
    request = CL_IDENT_PROX_MOD;
  if (OPT_CL_REV_PROX_MOD())
    request = CL_IDENT_REV_PROX_MOD;
    }
  else
    {
      if (OPT_CL_NORMAL_MOD())
	request = CL_IDENT_ASKED_SHELL_C;
      if (OPT_RSHELL())
	request = CL_IDENT_REV_SHELL_C;
      if (OPT_CL_LIST_MOD())
	request = CL_IDENT_LIST_PROX_C;
      if (OPT_CL_PROX_MOD())
	request = CL_IDENT_PROX_MOD_C;
      if (OPT_CL_REV_PROX_MOD())
	request = CL_IDENT_REV_PROX_MOD_C;
    }
  return (request);
}
