/*
** CCTT - Covert Channel Tunneling Tool - v0.1.5
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: conf_file_FAKE_WEBSERVER.c,v 1.5 2003/04/23 07:06:10 simsim Exp $
**
** This file is part of CCTT - v0.1.5 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/definitions.h"

/*
** Cette fonction permet de charger en memoire une banniere qui sera renvoyee
** en cas de mauvaise identification / demande de service.
*/

void conf_file_FAKE_WEBSERVER(S_OPTIONS *options,char *function, char *params)
{
  FILE *fake_file;
  int nb_oct;

  /* Suremment pas en mode client */
  if (OPT_CL_OR_SRV())
    cctt_error_and_exit(stderr,"[Conf] : Using %s in client mode is not valid !\n",function);

  if (!params || strlen(params) == 0)
    cctt_error_and_exit(stderr,"[Conf] : FAKE_WEBSERVER %s directive is incomplete !\n",params);
  
  if ((fake_file = fopen(params,"r")) == NULL)
    cctt_error_and_exit(stderr,"[Conf] : FAKE_WEBSERVER : %s file is not valid !\n",params);
  else
    {
      fseek(fake_file,0,SEEK_END);
      nb_oct = ftell(fake_file);
      if (nb_oct < 1)
	{
	  fclose(fake_file);
	  cctt_error_and_exit(stderr,"[Conf] : FAKE_WEBSERVER : %s file is not valid !\n",params);
	}
      fseek(fake_file,0,SEEK_SET);
      options->srv_options->fake_webserver = (char *) malloc (nb_oct);
      memset(options->srv_options->fake_webserver,0,nb_oct);
      fread(options->srv_options->fake_webserver,nb_oct-1,1,fake_file);
      cctt_debug(stderr,"Init : ConfFile(C) - FAKE_WEBSERVER, %d octets lus",nb_oct-1);
      fclose(fake_file);
    }
}
