/*
** CCTT - Covert Channel Tunneling Tool - v0.1.7
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: conf_file_KILL.c,v 1.2 2003/06/10 15:21:17 simsim Exp $
**
** This file is part of CCTT - v0.1.7 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/definitions.h"

/*
** Ces fonctions sont reservees au serveur...
** Elles permettent de positionner un timer pour fermer les connections
** quiet depuis x msecs ou quiet depuis y msecs avec le close_flag positionne.
*/

/*
** Delai pour les connexions quiet depuis x secs.
*/

void conf_file_KILL_QUIET_DEL(S_OPTIONS *options,char *function, char *params)
{
  int i;

  /* Suremment pas en mode client */
  if (OPT_CL_OR_SRV())
    cctt_error_and_exit(stderr,"[Conf] : Using %s in client mode is not valid !",function);

  if (!params || strlen(params) == 0)
    cctt_error_and_exit(stderr,"[Conf] : KILL_QUIET_DEL %s directive is incomplete !",params);

  /* Verifie que notre appel atoi() va fonctionner */
  for (i=0;i<strlen(params);i++)
    if (!isdigit(params[i]))
      cctt_error_and_exit(stderr,"[Conf] : KILL_QUIET_DEL (%s) directive is invalid !",params);

  options->srv_options->kill_quiet_del = (int) atoi(params);
  cctt_debug(stderr,"Init : ConfFile(C) - KILL_QUIET_DEL positionne a %d",options->srv_options->kill_quiet_del);
}

/*
** Delai pour les connexions avec le close flag.
*/

void conf_file_KILL_QUIET_DEL_CF(S_OPTIONS *options,char *function, char *params)
{
  int i;

  /* Suremment pas en mode client */
  if (OPT_CL_OR_SRV())
    cctt_error_and_exit(stderr,"[Conf] : Using %s in client mode is not valid !",function);

  if (!params || strlen(params) == 0)
    cctt_error_and_exit(stderr,"[Conf] : KILL_QUIET_DEL_CF %s directive is incomplete !",params);

  /* Verifie que notre appel atoi() va fonctionner */
  for (i=0;i<strlen(params);i++)
    if (!isdigit(params[i]))
      cctt_error_and_exit(stderr,"[Conf] : KILL_QUIET_DEL_CF (%s) directive is invalid !",params);

  options->srv_options->kill_quiet_del_cf = (int) atoi(params);
  cctt_debug(stderr,"Init : ConfFile(C) - KILL_QUIET_DEL_CF positionne a %d",options->srv_options->kill_quiet_del_cf);
}
