/*
** CCTT - Covert Channel Tunneling Tool - v0.1.5
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: conf_file_PROTOCOL.c,v 1.5 2003/04/23 07:06:10 simsim Exp $
**
** This file is part of CCTT - v0.1.5 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/definitions.h"

/*
** Cette fonction positionne le protocole qui sera utilise
** pour l'etablissement de la socket entre le client et le serveur
*/

void conf_file_PROTOCOL(S_OPTIONS *options,char *function, char *params)
{
  /* Positionne le protocole demande */
  if (OPT_CL_OR_SRV()) /* Si client */
    {
      if ((strcmp(params,"tcp")) == 0)
	options->cl_options->protocol = OPT_CL_PROT_TCP;
      if ((strcmp(params,"udp")) == 0)
	options->cl_options->protocol = OPT_CL_PROT_UDP;
      cctt_debug(stderr,"Init : ConfFile(C) - PROTOCOL = %d",options->cl_options->protocol);
    }
  else /* Si serveur */
    {
      if ((strcmp(params,"tcp")) == 0)
	options->srv_options->protocol = OPT_SRV_PROT_TCP;
      if ((strcmp(params,"udp")) == 0)
	options->srv_options->protocol = OPT_SRV_PROT_UDP;
      cctt_debug(stderr,"Init : ConfFile(S) - PROTOCOL = %d",options->srv_options->protocol);
    }

  /* Envoie une erreur si le protocol n'est pas gere */
  if (options->srv_options->protocol == 0 && options->cl_options->protocol == 0)
    cctt_error_and_exit(stderr,"[Conf] : protocol %s is not valid !\n",params);
}
