/*
** CCTT - Covert Channel Tunneling Tool - v0.1.5
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: conf_file_PROXY_ONLY.c,v 1.5 2003/04/23 07:06:10 simsim Exp $
**
** This file is part of CCTT - v0.1.5 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/definitions.h"

/*
** Cette fonction est reservee au serveur.
** Elle permet de lancer le serveur en mode Proxy uniquement :
** # Pas de gestion de reverse-shell
** # Pas de gestion de shell
** # Pas d'interface de commande.
** => Le serveur peut ainsi etre lance en background
*/

void conf_file_PROXY_ONLY(S_OPTIONS *options,char *function, char *params)
{
  /* Suremment pas en mode client */
  if (OPT_CL_OR_SRV())
    cctt_error_and_exit(stderr,"[Conf] : Using %s in client mode is not valid !\n",function);

  if (!params || strlen(params) == 0)
    cctt_error_and_exit(stderr,"[Conf] : PROXY_ONLY %s directive is incomplete !\n",params);

  if (strlen(params) == 2 && strncmp(params,"ON",2) == 0)
    options->srv_options->proxy_only = 1;
  else
    options->srv_options->proxy_only = 0;
}

