/*
** CCTT - Covert Channel Tunneling Tool - v0.1.5
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: conf_file_SRV.c,v 1.5 2003/04/23 07:06:10 simsim Exp $
**
** This file is part of CCTT - v0.1.5 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/definitions.h"

/*
** Cette fonction est appelle lors des verifications de configuration de 
** derniere minute et s'assure que le shell serveur est bien positionne.
** Sinon, elle met /bin/false dedans.
*/

void check_srv_shell_configuration(S_OPTIONS *options)
{
  /* Que en mode serveur */
  if (! OPT_CL_OR_SRV())
    {
      if (! options->srv_options->srv_shell_loc)
	{
	  options->srv_options->srv_shell_loc = (char *) malloc (strlen(SRV_RSHELL_LOCATION)+1);
	  memset(options->srv_options->srv_shell_loc,0,strlen(SRV_RSHELL_LOCATION)+1);
	  strncpy(options->srv_options->srv_shell_loc,SRV_RSHELL_LOCATION,strlen(SRV_RSHELL_LOCATION));
	}
      if (! options->srv_options->srv_shell_cmd)
	{
	  options->srv_options->srv_shell_cmd = (char *) malloc (strlen(SRV_RSHELL_NAME)+1);
	  memset(options->srv_options->srv_shell_cmd,0,strlen(SRV_RSHELL_NAME)+1);
	  strncpy(options->srv_options->srv_shell_cmd,SRV_RSHELL_NAME,strlen(SRV_RSHELL_NAME));
	}
    }
}

/*
** Cette fonction positionne le shell qui sera utilise par les clients s'ils en
** demandent un au serveur
*/

void conf_file_SRV_SHELL_LOC(S_OPTIONS *options,char *function, char *params)
{
  /* Suremment pas en mode client */
  if (OPT_CL_OR_SRV())
    cctt_error_and_exit(stderr,"[Conf] : Using %s in client mode is not valid !\n",function);

  options->srv_options->srv_shell_loc = (char *) malloc (strlen(params)+1);
  memset(options->srv_options->srv_shell_loc,0,strlen(params)+1);
  strncpy(options->srv_options->srv_shell_loc,params,strlen(params));
  cctt_debug(stderr,"Init : ConfFile(C) - SRV_SHELL_LOC, shell %s positionne",params);
}

void conf_file_SRV_SHELL_CMD(S_OPTIONS *options,char *function, char *params)
{
  /* Suremment pas en mode client */
  if (OPT_CL_OR_SRV())
    cctt_error_and_exit(stderr,"[Conf] : Using %s in client mode is not valid !\n",function);

  options->srv_options->srv_shell_cmd = (char *) malloc (strlen(params)+1);
  memset(options->srv_options->srv_shell_cmd,0,strlen(params)+1);
  strncpy(options->srv_options->srv_shell_cmd,params,strlen(params));
  cctt_debug(stderr,"Init : ConfFile(C) - SRV_SHELL_CMD, shell %s positionne",params);
}
