/*
** CCTT - Covert Channel Tunneling Tool - v0.1.7
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: conf_file_functions.c,v 1.5 2003/06/10 15:21:17 simsim Exp $
**
** This file is part of CCTT - v0.1.7 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/definitions.h"

/*
** Tableau contenant les parametres qui sont geres dans les fichiers
** de configuration. L'index dans ce tableau permet d'aller chercher
** un pointeur sur fonction dans le tableau suivant.
**
*/

char *ConfigFileFunctionsArray[] = {
  "PROTOCOL",
  "PROXY_MODE_LIST",
  "CHANNEL_PROXY_IP",
  "CHANNEL_PROXY_PORT",
  "CHANNEL_PROXY_PROT",
  "PROXY_MODE_LOCAL_IP",
  "PROXY_MODE_LOCAL_PORT",
  "PROXY_MODE_PROT",
  "PROXY_MODE_REMOTE_IP",
  "PROXY_MODE_REMOTE_PORT",
  "IDENT",
  "IDENT_KEY",
  "SRV_SHELL_LOC",
  "SRV_SHELL_CMD",
  "PROXY_ONLY",
  "PERM_USER_GROUP",
  "PERM_CHROOT",
  "HTTP_PROXY_CHAIN",
  "CHANNEL_PROXY_DEL",
  "FAKE_WEBSERVER",
  "HTTP_MOD_CL_REQ_PER_CON",
  "HTTP_MOD_CL_DELAY_BET_CON",
  "HTTP_MOD_CL_TOP_PAD",
  "HTTP_MOD_CL_BOT_PAD",
  "HTTP_MOD_CL_FAKE_URLS",
  "HTTP_MOD_CL_FAKE_URLS_FREQ",
  "HTTP_MOD_CL_HOSTNAME",
  "HTTP_MOD_CL_CONTENTTYPE",
  "HTTP_MOD_CL_DATASIZE",
  "HTTP_MOD_URI",
  "HTTP_MOD_SRV_FAKE_URLS",
  "HTTP_MOD_SRV_TOP_PAD",
  "HTTP_MOD_SRV_BOT_PAD",
  "HTTP_MOD_SRV_ERROR_PAGE",
  "KILL_QUIET_DEL",
  "KILL_QUIET_DEL_CF",
  NULL
};

/*
** Tableau contenant les pointeurs sur fonctions pour 
** la validation des parametres presents dans les fichiers
** de configuration.
** Le nom de la fonction figurant dans le tableau doit etre
** positionne au meme index que le nom de parametre du fichier
** de configuration qui est renseigne dans le tableau precedent.
*/

void *ConfigFileArrayPtr[] = {
  conf_file_PROTOCOL,
  conf_file_PROXY_MODE_LIST,
  conf_file_CHANNEL_PROXY_IP,
  conf_file_CHANNEL_PROXY_PORT,
  conf_file_CHANNEL_PROXY_PROT,
  conf_file_PROXY_MODE_LOCAL_IP,
  conf_file_PROXY_MODE_LOCAL_PORT,
  conf_file_PROXY_MODE_PROT,
  conf_file_PROXY_MODE_REMOTE_IP,
  conf_file_PROXY_MODE_REMOTE_PORT,
  conf_file_IDENT,
  conf_file_IDENT_KEY,
  conf_file_SRV_SHELL_LOC,
  conf_file_SRV_SHELL_CMD,
  conf_file_PROXY_ONLY,
  conf_file_PERM_USER_GROUP,
  conf_file_PERM_CHROOT,
  conf_file_HTTP_PROXY_CHAIN,
  conf_file_CHANNEL_PROXY_DEL,
  conf_file_FAKE_WEBSERVER,
  conf_file_HTTP_MOD_CL_REQ_PER_CON,
  conf_file_HTTP_MOD_CL_DELAY_BET_CON,
  conf_file_HTTP_MOD_CL_TOP_PAD,
  conf_file_HTTP_MOD_CL_BOT_PAD,
  conf_file_HTTP_MOD_CL_FAKE_URLS,
  conf_file_HTTP_MOD_CL_FAKE_URLS_FREQ,
  conf_file_HTTP_MOD_CL_HOSTNAME,
  conf_file_HTTP_MOD_CL_CONTENTTYPE,
  conf_file_HTTP_MOD_CL_DATASIZE,
  conf_file_HTTP_MOD_URI,
  conf_file_HTTP_MOD_SRV_FAKE_URLS,
  conf_file_HTTP_MOD_SRV_TOP_PAD,
  conf_file_HTTP_MOD_SRV_BOT_PAD,
  conf_file_HTTP_MOD_SRV_ERROR_PAGE,
  conf_file_KILL_QUIET_DEL,
  conf_file_KILL_QUIET_DEL_CF,
  NULL
};

