/*
** CCTT - Covert Channel Tunneling Tool - v0.1.7
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: drop_priviledges.c,v 1.2 2003/05/22 10:36:57 simsim Exp $
**
** This file is part of CCTT - v0.1.7 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/definitions.h"

void drop_priviledges(S_OPTIONS *options)
{

  /*
  ** Securisation du serveur (si execution en tant que root) :
  ** Si la directive PERM_USER_GROUP n'est pas positionnee on quitte.
  ** Si la directive PERM_CHROOT est positionne, on chroote dans le repertoire parametre.
  ** On change ensuite le gid puis l'uid du processus serveur.
  */

  if (geteuid() == 0)
    {
      /* On va suremment pas lancer Cctt en root */
      if (options->srv_options->perm_uid == 0 || options->srv_options->perm_gid == 0)
	cctt_error_and_exit(stderr,"%s","[Options] : Not reccomanded to execute CCTT with euid 0 without removing privileges !\n");

      /* Si le chroot est demande */
      if (options->srv_options->perm_chroot != NULL)
	{
	   if (chroot(options->srv_options->perm_chroot) != 0)
	     {
	       fprintf (stdout,"\n Priviledges restrictions : error while trying to chroot in %s.\n",
			options->srv_options->perm_chroot);
	       exit (0);
	     }
	   cctt_debug(stderr,"%s","Init : Restriction des privileges Chroot Ok");
	}

      /* On droppe les privileges de groupe */
      if (setgid(options->srv_options->perm_gid) != 0)
	{
	  fprintf (stdout,"\n Priviledges restrictions : error while trying to set the gid to %d.\n",options->srv_options->perm_gid);
	  exit (0);
	}

      /* On dropper les privileges d'utilisateur */
      if (setuid(options->srv_options->perm_uid) != 0)
	{
	  fprintf (stdout,"\n Priviledges restrictions : error while trying to set the uid to %d\n",options->srv_options->perm_uid);
	  exit (0);
	}
      cctt_debug(stderr,"%s","Init : Restriction des privileges Uid/Gid Ok");
    }
}
