/*
** CCTT - Covert Channel Tunneling Tool - v0.1.5
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: error_and_debug.c,v 1.5 2003/04/23 07:06:10 simsim Exp $
**
** This file is part of CCTT - v0.1.5 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/definitions.h"

/*
** Figurent ici les fonctions permettant d'afficher les messages d'erreur ou de debug.
** Note : Elles sont toutes baties sur le meme modele et utilisent toute la fonction 
**   cctt_display_loop() presente dans verbose.c
*/

int cctt_debug(FILE *stream, char *fmt, ...)
{
  va_list params;
  char *res;
  int cpt_res;

  if (GLOBAL_DEBUG == 0)
    return (0);
  if (!fmt || !stream)
    return (0);

  va_start(params,fmt);
  if ((res = cctt_display_loop(fmt,params)) == NULL)
    return (0);
  res = ascii_this_string(res);
  va_end(params);
  cpt_res = fprintf(stream,"%s","  -/CCTT DEBUG/ ");
  cpt_res += fprintf(stream,"%s",res);
  cpt_res += fprintf(stream,"%s"," /CCTT DEBUG/-\n");

  if (res)
    free (res);
  return (cpt_res);
}

int cctt_error(FILE *stream, char *fmt, ...)
{
  va_list params;
  char *res;
  int cpt_res;

  if (!fmt || !stream)
    return (0);

  va_start(params,fmt);
  if ((res = cctt_display_loop(fmt,params)) == NULL)
    return (0);
  va_end(params);
  cpt_res = fprintf(stream,"%s","ERROR / ");
  cpt_res += fprintf(stream,"%s",res);
  cpt_res += fprintf(stream,"%s","/ ERROR\n");

  if (res)
    free (res);
  return (cpt_res);
}


int cctt_error_and_exit(FILE *stream, char *fmt, ...)
{
  va_list params;
  char *res;
  int cpt_res;

  if (!fmt || !stream)
    exit (0);

  va_start(params,fmt);
  if ((res = cctt_display_loop(fmt,params)) == NULL)
    exit (0);
  va_end(params);
  cpt_res = fprintf(stream,"%s","EXIT_ERROR / ");
  cpt_res += fprintf(stream,"%s",res);
  cpt_res += fprintf(stream,"%s","/ EXIT_ERROR\n");
  
  if (res)
    free (res);
  exit (1);
}
