/*
** CCTT - Covert Channel Tunneling Tool - v0.1.5
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: parse_cmd.c,v 1.5 2003/04/23 07:06:10 simsim Exp $
**
** This file is part of CCTT - v0.1.5 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/definitions.h"

T_srv_cmd srv_cmd_array[] = {
  {"help",parse_cmd_help},
  {"quit",parse_cmd_quit},
  {"show connections",parse_cmd_show_connections},
  {"show params",parse_cmd_show_params},
  {"kill connection",parse_cmd_kill_connection},
  {"kill manager",parse_cmd_kill_manager},
  {"tell client",parse_cmd_tell_client},
  {NULL,NULL}
};

void parse_cmd(S_OPTIONS *options, char *buffer)
{
  int cpt,exit;

  chomp(buffer);

  for (cpt=0,exit=0;srv_cmd_array[cpt].cmd_label != NULL; cpt++)
    {
      if ((strncmp(buffer,srv_cmd_array[cpt].cmd_label,strlen(srv_cmd_array[cpt].cmd_label))) == 0)
	{
	  srv_cmd_array[cpt].srv_cmd_ptr(options,buffer);
	  exit = 1;
	}
    }
  if (exit == 0 && strlen(buffer) != 0)
    cctt_error(stderr,"[Server] : Command '%s' doesn't exist !!!\nUse help to list commands.\n",buffer);
}
