/*
** CCTT - Covert Channel Tunneling Tool - v0.1.5
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: send_cl_proxying_request.c,v 1.6 2003/06/10 15:21:17 simsim Exp $
**
** This file is part of CCTT - v0.1.5 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/definitions.h"

/*
**  Envoie la demande de proxying au serveur
*/

void send_cl_proxying_request(S_OPTIONS *options, struct sockaddr_in cl_prox_sockaddr)
{
  int nw;
  T_cl_proxying_request proxying_request;
  struct hostent *he;

  int tmpsize;
  char *tmp;

  /* Initialisation structure */
  memset(&proxying_request,0,sizeof(T_cl_proxying_request));

  /* On ajoute le protocole */
  proxying_request.protocol = options->cl_options->dest_server_proxy_mode_prot;

  /* On cree et ajoute la struct sockaddr */
  he = (struct hostent *) gethostbyname(options->cl_options->dest_server_proxy_mode_address);
  proxying_request.sockaddr.sin_family = PF_INET;
  proxying_request.sockaddr.sin_addr = *((struct in_addr *) he->h_addr);
  bzero(&(proxying_request.sockaddr.sin_zero), sizeof(proxying_request.sockaddr.sin_zero));
  proxying_request.sockaddr.sin_port = htons(options->cl_options->dest_server_proxy_mode_port);

  /* On ajoute les informations sur le client faisant la demande de proxy */
  memcpy(&proxying_request.cl_prox_sockaddr,&cl_prox_sockaddr,sizeof(cl_prox_sockaddr));

  cctt_debug(stderr,"PMod : Client : La requete proxy du client contient '%s'",inet_ntoa(proxying_request.sockaddr.sin_addr));
  cctt_debug(stderr,"PMod : Client : La requete proxy du client contient '%d'",ntohs(proxying_request.sockaddr.sin_port));

  /* Toujours ce probleme avec l'envoi d'une structure */

  tmpsize = sizeof(struct sockaddr_in)*2+2;
  tmp = (char *) malloc (tmpsize);
  memset (tmp,0,tmpsize);
  *tmp = proxying_request.protocol;
  memcpy(tmp+1,&proxying_request.sockaddr,sizeof(struct sockaddr_in));
  memcpy(tmp+2+sizeof(struct sockaddr_in),&proxying_request.cl_prox_sockaddr,sizeof(struct sockaddr_in));
 
  /* On envoie notre 'structure' */
  nw = do_client_has_something_to_encode(options,options->cl_options->sd,tmp,sizeof(struct sockaddr_in)*2+2);

  cctt_verbose(stderr,"Client is sending proxying request (%d bytes).\n",nw);
}
