/*
** CCTT - Covert Channel Tunneling Tool - v0.1.7
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: send_proxy_list_and_close.c,v 1.6 2003/06/10 15:21:17 simsim Exp $
**
** This file is part of CCTT - v0.1.7 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/definitions.h"

/*
** Envoit la liste configuree pour proxying au client et quitte.
*/

#define SORRY_NO_PROXY_LIST "Sorry, No proxy list configured...\n"
#define PROXY_LIST_IS "\nProxy list is :\n"
#define PROXY_ONLY_LIST_IS "\nProxy list is (Server in proxy_only mode) :\n"

void send_proxy_list_and_close(S_OPTIONS *options, int cl_num)
{
  T_proxy_allowed_list *tmp_list;
  char *buffer;
  int buf_size;
  int dw;

  cctt_verbose(stderr,"Client %d asked the proxy list... Sending and closing...\n",cl_num);

  /*
  ** Quel choix ? plusieurs malloc ou plusieurs write ?
  ** Ne sais pas ... en tout cas, c'est porc...
  */

  if (options->srv_options->proxy_allowed_list_elements_number != 0)
    {
      /* On se positionne sur le premier */
      tmp_list = options->srv_options->proxy_allowed_list->first;
      
      if (OPT_SRV_PROXY_ONLY())
	dw = do_server_has_something_to_encode(options,cl_num,PROXY_ONLY_LIST_IS,strlen(PROXY_ONLY_LIST_IS));
      else
	dw = do_server_has_something_to_encode(options,cl_num,PROXY_LIST_IS,strlen(PROXY_LIST_IS));

      /* Tant que le suivant n'est pas nul */
      while (tmp_list->next != NULL)
	{
	  buf_size = strlen(tmp_list->label)+strlen(inet_ntoa(tmp_list->sockaddr.sin_addr))+5+4;
	  buffer = (char *) malloc (buf_size+1);
	  memset(buffer,0,buf_size+1);
	  snprintf(buffer,buf_size,"%s:%s:%d\n",
		   tmp_list->label,
		   inet_ntoa(tmp_list->sockaddr.sin_addr),
		   ntohs(tmp_list->sockaddr.sin_port));
	  dw = do_server_has_something_to_encode(options,cl_num,buffer,buf_size+1);
	  free (buffer);
	  tmp_list = tmp_list->next;
	}
      /* On n'oublie pas le dernier */
      buf_size = strlen(tmp_list->label)+strlen(inet_ntoa(tmp_list->sockaddr.sin_addr))+5+4;
      buffer = (char *) malloc (buf_size+1);
      memset(buffer,0,buf_size+1);
      snprintf(buffer,buf_size,"%s:%s:%d\n",
	       tmp_list->label,
	       inet_ntoa(tmp_list->sockaddr.sin_addr),
	       ntohs(tmp_list->sockaddr.sin_port));
      dw = do_server_has_something_to_encode(options,cl_num,buffer,buf_size+1);
      free (buffer);
    }
  else
    dw = do_server_has_something_to_encode(options,cl_num,SORRY_NO_PROXY_LIST,strlen(SORRY_NO_PROXY_LIST));

  reset_client_connection(options,cl_num);
}


