/*
** CCTT - Covert Channel Tunneling Tool - v0.1.7
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: server_do_socket.c,v 1.6 2003/06/10 15:21:17 simsim Exp $
**
** This file is part of CCTT - v0.1.7 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/definitions.h"

/*
** Notes : 
**  $ reset_client_connection : voir src/server/server_functions.c
**  $ srv_ident_client : voir src/server/srv_ident_client.c
*/

void server_do_socket(S_OPTIONS *options, int sd, char *buffer, int nwr)
{
  int ident;

  /*
  ** Le client n'est pas encore identifie
  */ 
  if (SRV_CL_IDENT(options->srv_options->connect_infos->sd_table[sd].ident) == SRV_CL_IDENT_NO)
    {
      if ((ident = srv_ident_client(options,buffer,sd,nwr)) == SRV_CL_IDENT_NO)
	{
	  /* L'identification envoyee est incorrecte */
	  cctt_verbose(stderr,"Client %d failed to authenticate.\n",sd);
	  /*cctt_debug(stderr,"Its IDENT_KEY was '%s' ?!?.\n",buffer);*/
	  reply_as_fake_webserver(options,sd);
	  reset_client_connection(options,sd);
	}
      else
	{

	  /* L'identification est correcte */
	  options->srv_options->connect_infos->sd_table[sd].ident = ident;
	  /* Si le client est identifie ET que la connexion n'est pas encore down */
	  if (SRV_CL_IDENT(ident) == SRV_CL_IDENT_YES &&
	      options->srv_options->connect_infos->sd_table[sd].used & SRV_SD_USED)
	    cctt_verbose(stderr,"Client %d - %d is authenticated.\n",
			 sd,options->srv_options->connect_infos->sd_table[sd].magic_number);
	}
    }
  else
    {
      /* 
      ** Le client est deja identifie et n'est pas gere pas un manager...
      ** Ex: RShell ou Proxy
      */
      srv_manage_connection_type(options, sd, buffer, nwr);
    }
}
