/*
** CCTT - Covert Channel Tunneling Tool - v0.1.5
** Copyright (C) 2002,2003 Simon Castro - scastro@entreelibre.com
** $Id: srv_manage_connection_type.c,v 1.6 2003/06/10 15:21:17 simsim Exp $
**
** This file is part of CCTT - v0.1.5 (C) 2002,2003 Simon Castro.
** 
** Cctt is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctt is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctt; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/definitions.h"

/*
** Le client s'est identifie et a demande un type correct de connexion.
** A l'entree de cette fonction, on a le buffer lu par le serveur que vient
**   d'envoyer le client et le numero de client (sd).
** En fonction du type de connexion, on renvoit vers la bonne fonction.
**
** Cette fonction est appellee quand le client n'est pas geree par un manager.
*/

void srv_manage_connection_type(S_OPTIONS *options, int cl_num, char *buffer, int nwr)
{
  char tos;
  char auth;

  tos = options->srv_options->connect_infos->sd_table[cl_num].tos;
  auth = options->srv_options->connect_infos->sd_table[cl_num].proxy_auth;

  /* Client en reverse shell, on affiche ce qu'il dit */
  if (tos == CL_IDENT_REV_SHELL)
    client_told(options,cl_num,buffer);

  /* Client en demande d'autorisation de proxy */
  if (tos == CL_IDENT_PROX_MOD && auth == SRV_CL_PROX_NO)
    if (client_wants_proxying_to(options,cl_num,buffer,nwr) == 0)
      reset_client_connection(options,cl_num);

  /* Client en mode proxy et autorise */
  if (tos == CL_IDENT_PROX_MOD && (auth == SRV_CL_PROX_YES || auth == SRV_CL_PROX_REV))
    client_spoke_to_proxy(options,cl_num,buffer,nwr);

  /* Client nous informe qu'il peut proxyier vers ... */
  if (tos == CL_IDENT_REV_PROX_MOD && auth == SRV_CL_PROX_NO)
    {
      if (client_tells_hes_proxying_to(options,cl_num,buffer,nwr) == 0)
	reset_client_connection(options,cl_num);
      else
	options->srv_options->connect_infos->sd_table[cl_num].proxy_auth = SRV_CL_PROX_REV;
    }

  /* Ce client nous envoie des donnees des clients qui sont derriere lui */
  
  if (tos == CL_IDENT_REV_PROX_MOD && auth == SRV_CL_PROX_REV)
    remove_overhead_from_rev_prox_mode(options,cl_num,buffer,nwr);
}

